loci.formats.in

## Class CellWorxReader

- java.lang.Object
- - loci.formats.FormatHandler
  - - loci.formats.FormatReader
    - - loci.formats.in.CellWorxReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, ICompressedTileReader, IFormatHandler, IFormatReader, IMetadataConfigurable, IPyramidHandler
  Direct Known Subclasses:
    MetaxpressTiffReader

      public class CellWorxReader
      extends FormatReader

  CellWorxReader is the file format reader for CellWorx .pnl files.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static java.lang.String` | `DATE_FORMAT`
    `protected java.lang.String[]` | `directoryList`
    `protected boolean` | `doChannels`
    `protected int` | `fieldCount`
    `private boolean[][]` | `fieldMap`
    `private java.lang.String` | `lastFile`
    `private IFormatReader` | `lastReader`
    `private java.lang.String[][]` | `logFiles`
    `protected int` | `nTimepoints`
    `private java.lang.String` | `plateLogFile`
    `private OMEXMLService` | `service`
    `protected boolean` | `subdirectories`
    `private java.util.HashMap<java.lang.Integer,ome.xml.model.primitives.Timestamp>` | `timestamps`
    `protected java.lang.String[]` | `wavelengths`
    `protected int` | `wellCount`
    `protected java.lang.String[][][]` | `wellFiles`
    `private java.lang.String` | `zMapFile`
    `protected int` | `zSteps`

    - ### Fields inherited from class loci.formats.FormatReader

      `core, coreIndex, datasetDescription, domains, fillColor, filterMetadata, flattenedResolutions, group, hasCompanionFiles, in, indexedAsRGB, metadata, metadataStore, normalizeData, resolution, saveOriginalMetadata, series, suffixNecessary, suffixSufficient, THUMBNAIL_DIMENSION`

    - ### Fields inherited from class loci.formats.FormatHandler

      `COMPRESSION_SUFFIXES, currentId, format, LOGGER, metadataOptions, suffixes`

    - ### Fields inherited from interface loci.formats.IFormatReader

      `CAN_GROUP, CANNOT_GROUP, MUST_GROUP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CellWorxReader()` Constructs a new CellWorx reader.
    `CellWorxReader(java.lang.String name, java.lang.String[] extensions)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close(boolean fileOnly)` Closes the currently open file.
    `int` | `fileGroupOption(java.lang.String id)` Returns an indication of whether the files in a multi-file dataset can be handled individually.
    `protected void` | `findPixelsFiles()`
    `protected boolean` | `foundHTDFile(java.lang.String name)`
    `private java.lang.String` | `getFile(int seriesIndex, int no)` Retrieve the .pnl file corresponding to the given series.
    `protected java.lang.String` | `getPlateName(java.lang.String id)`
    `protected IFormatReader` | `getReader(java.lang.String file, boolean omexml)`
    `java.lang.String[]` | `getSeriesUsedFiles(boolean noPixels)` Returns an array of filenames needed to open the current series.
    `private int` | `getWell(int seriesIndex)` Retrieve the well index corresponding to the given series.
    `protected int` | `getWellColumn(int seriesIndex)` Retrieve the well column corresponding to the given series.
    `protected int` | `getWellRow(int seriesIndex)` Retrieve the well row corresponding to the given series.
    `protected void` | `initFile(java.lang.String id)` Initializes the given file (parsing header information, etc.).
    `protected void` | `initReader(IFormatReader reader, java.lang.String file, boolean omexml)`
    `boolean` | `isThisType(java.lang.String name, boolean open)` Checks if a file matches the type of this format reader.
    `byte[]` | `openBytes(int no, byte[] buf, int x, int y, int w, int h)` Obtains a sub-image of the specified image plane into a pre-allocated byte array.
    `protected void` | `parseHTD()`
    `protected void` | `parseWellLogFile(int wellIndex, MetadataStore store)` Parse metadata from a well log file.
    `protected void` | `populateMetadata()`

    - ### Methods inherited from class loci.formats.FormatReader

      `addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMetaList, addMeta, addMetaList, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMetaList, close, coreIndexToSeries, flattenHashtables, get16BitLookupTable, get8BitLookupTable, getAcquisitionMode, getAdvancedSeriesUsedFiles, getAdvancedUsedFiles, getArcType, getAvailableOptions, getBinning, getBitsPerPixel, getCompression, getContrastMethod, getCoreIndex, getCoreMetadataList, getCorrection, getCurrentCore, getCurrentFile, getDatasetStructureDescription, getDetectorType, getDimensionOrder, getDimensionOrder, getDomains, getEffectiveSizeC, getExperimentType, getFilamentType, getFillColor, getFillRule, getFilterType, getFontFamily, getFontStyle, getGlobalMeta, getGlobalMetadata, getIlluminationType, getImageCount, getImmersion, getIndex, getIndex, getLaserMedium, getLaserType, getMarker, getMedium, getMetadataStore, getMetadataStoreRoot, getMetadataValue, getMicrobeamManipulationType, getMicroscopeType, getModuloC, getModuloT, getModuloZ, getNamingConvention, getOptimalTileHeight, getOptimalTileWidth, getPixelType, getPixelType, getPossibleDomains, getPulse, getRequiredDirectories, getResolution, getResolutionCount, getRGBChannelCount, getRotationTransform, getSeries, getSeriesCount, getSeriesMeta, getSeriesMetadata, getSeriesMetadataValue, getSeriesUsedFiles, getSizeC, getSizeT, getSizeX, getSizeY, getSizeZ, getThumbSizeX, getThumbSizeY, getTileColumns, getTileRows, getUnderlyingReaders, getUsedFiles, getUsedFiles, getZCTCoords, getZCTModuloCoords, hasCompanionFiles, hasFlattenedResolutions, isFalseColor, isGroupFiles, isIndexed, isInterleaved, isInterleaved, isLittleEndian, isMetadataComplete, isMetadataFiltered, isNormalized, isOrderCertain, isOriginalMetadataPopulated, isRGB, isSingleFile, isThisType, isThisType, isThisType, isThumbnailSeries, isUsedFile, makeFilterMetadata, openBytes, openBytes, openBytes, openPlane, openThumbBytes, readPlane, readPlane, readPlane, reopenFile, seriesToCoreIndex, setCoreIndex, setFillColor, setFlattenedResolutions, setGroupFiles, setId, setMetadataFiltered, setMetadataStore, setNormalized, setOriginalMetadataPopulated, setResolution, setSeries, updateMetadataLists`

    - ### Methods inherited from class loci.formats.FormatHandler

      `checkSuffix, checkSuffix, getFormat, getMetadataOptions, getNativeDataType, getSuffixes, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface loci.formats.IFormatHandler

      `getFormat, getNativeDataType, getSuffixes`

    - ### Methods inherited from interface loci.formats.IMetadataConfigurable

      `getMetadataOptions, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from interface loci.formats.ICompressedTileReader

      `getTileCodec, getTileCodecOptions, openCompressedBytes, openCompressedBytes`

- - ### Field Detail

    - #### DATE_FORMAT

          protected static final java.lang.String DATE_FORMAT

      See Also:
        Constant Field Values

    - #### fieldMap

          private boolean[][] fieldMap

    - #### wellFiles

          protected java.lang.String[][][] wellFiles

    - #### logFiles

          private java.lang.String[][] logFiles

    - #### fieldCount

          protected int fieldCount

    - #### doChannels

          protected boolean doChannels

    - #### plateLogFile

          private java.lang.String plateLogFile

    - #### zMapFile

          private java.lang.String zMapFile

    - #### lastFile

          private java.lang.String lastFile

    - #### lastReader

          private IFormatReader lastReader

    - #### service

          private OMEXMLService service

    - #### timestamps

          private java.util.HashMap<java.lang.Integer,ome.xml.model.primitives.Timestamp> timestamps

    - #### directoryList

          protected java.lang.String[] directoryList

    - #### subdirectories

          protected boolean subdirectories

    - #### wavelengths

          protected java.lang.String[] wavelengths

    - #### nTimepoints

          protected int nTimepoints

    - #### zSteps

          protected int zSteps

    - #### wellCount

          protected int wellCount

  - ### Constructor Detail

    - #### CellWorxReader

          public CellWorxReader()

      Constructs a new CellWorx reader.

    - #### CellWorxReader

          public CellWorxReader(java.lang.String name,
                                java.lang.String[] extensions)

  - ### Method Detail

    - #### fileGroupOption

          public int fileGroupOption(java.lang.String id)
                              throws FormatException,
                                     java.io.IOException

      Description copied from interface: `IFormatReader`
      Returns an indication of whether the files in a multi-file dataset can be handled individually. This method is only useful for formats and datasets which contain multiple files.
      Specified by:
        `fileGroupOption` in interface `IFormatReader`
      Overrides:
        `fileGroupOption` in class `FormatReader`
      Parameters:
        `id` - a file in the multi-file dataset
      Returns:
        an int indicating that we cannot, must, or might group the files. A return value of `FormatTools.MUST_GROUP` indicates that the files cannot be handled separately; the reader will always detect and read all files in the dataset. `FormatTools.CAN_GROUP` indicates that the files may be handled separately, but file grouping must then be disabled via `IFormatReader.setGroupFiles(boolean)`. `FormatTools.CANNOT_GROUP` indicates that the files must be handled separately; the reader will not attempt to read all files in the dataset (this is rare).
      Throws:
        `FormatException`
        `java.io.IOException`
      See Also:
        `FormatTools.MUST_GROUP`, `FormatTools.CAN_GROUP`, `FormatTools.CANNOT_GROUP`

    - #### isThisType

          public boolean isThisType(java.lang.String name,
                                    boolean open)

      Description copied from class: `FormatReader`
      Checks if a file matches the type of this format reader. Checks filename suffixes against those known for this format. If the suffix check is inconclusive and the open parameter is true, the file is opened and tested with `FormatReader.isThisType(RandomAccessInputStream)`.
      Specified by:
        `isThisType` in interface `IFormatReader`
      Overrides:
        `isThisType` in class `FormatReader`
        `open` - If true, and the file extension is insufficient to determine the file type, the (existing) file is opened for further analysis.

    - #### getSeriesUsedFiles

          public java.lang.String[] getSeriesUsedFiles(boolean noPixels)

      Description copied from interface: `IFormatReader`
      Returns an array of filenames needed to open the current series. If the 'noPixels' flag is set, then only files that do not contain pixel data will be returned. The first element in the array is expected to be the path passed to `IFormatHandler.setId(String)`, if appropriate based upon 'noPixels'. The remaining elements are expected to be in a consistent order; if a directory listing is necessary to build the list then it should be sorted first.
      Specified by:
        `getSeriesUsedFiles` in interface `IFormatReader`
      Overrides:
        `getSeriesUsedFiles` in class `FormatReader`

    - #### openBytes

          public byte[] openBytes(int no,
                                  byte[] buf,
                                  int x,
                                  int y,
                                  int w,
                                  int h)
                           throws FormatException,
                                  java.io.IOException

      Description copied from interface: `IFormatReader`
      Obtains a sub-image of the specified image plane into a pre-allocated byte array.
      Specified by:
        `openBytes` in interface `IFormatReader`
      Specified by:
        `openBytes` in class `FormatReader`
      Parameters:
        `no` - the plane index within the current series.
        `buf` - a pre-allocated buffer.
        `x` - X coordinate of the upper-left corner of the sub-image
        `y` - Y coordinate of the upper-left corner of the sub-image
        `w` - width of the sub-image
        `h` - height of the sub-image
      Returns:
        the pre-allocated buffer `buf` for convenience.
      Throws:
        `FormatException` - if there was a problem parsing the metadata of the file.
        `java.io.IOException` - if there was a problem reading the file.
      See Also:
        `IFormatReader.openBytes(int, byte[], int, int, int, int)`

    - #### close

          public void close(boolean fileOnly)
                     throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Closes the currently open file. If the flag is set, this is all that happens; if unset, it is equivalent to calling `Closeable.close()`.
      Specified by:
        `close` in interface `IFormatReader`
      Overrides:
        `close` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### initFile

          protected void initFile(java.lang.String id)
                           throws FormatException,
                                  java.io.IOException

      Description copied from class: `FormatReader`
      Initializes the given file (parsing header information, etc.). Most subclasses should override this method to perform initialization operations such as parsing metadata.
      Overrides:
        `initFile` in class `FormatReader`
      Throws:
        `FormatException` - if a parsing error occurs processing the file.
        `java.io.IOException` - if an I/O error occurs processing the file

    - #### populateMetadata

          protected void populateMetadata()
                                   throws FormatException,
                                          java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### parseHTD

          protected void parseHTD()
                           throws FormatException,
                                  java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### getPlateName

          protected java.lang.String getPlateName(java.lang.String id)

    - #### findPixelsFiles

          protected void findPixelsFiles()
                                  throws FormatException

      Throws:
        `FormatException`

    - #### getWell

          private int getWell(int seriesIndex)

      Retrieve the well index corresponding to the given series.

    - #### getWellRow

          protected int getWellRow(int seriesIndex)

      Retrieve the well row corresponding to the given series.

    - #### getWellColumn

          protected int getWellColumn(int seriesIndex)

      Retrieve the well column corresponding to the given series.

    - #### getFile

          private java.lang.String getFile(int seriesIndex,
                                           int no)

      Retrieve the .pnl file corresponding to the given series.

    - #### parseWellLogFile

          protected void parseWellLogFile(int wellIndex,
                                          MetadataStore store)
                                   throws java.io.IOException

      Parse metadata from a well log file.
      Throws:
        `java.io.IOException`

    - #### getReader

          protected IFormatReader getReader(java.lang.String file,
                                            boolean omexml)
                                     throws FormatException,
                                            java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### initReader

          protected void initReader(IFormatReader reader,
                                    java.lang.String file,
                                    boolean omexml)
                             throws FormatException,
                                    java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### foundHTDFile

          protected boolean foundHTDFile(java.lang.String name)

Copyright © 2026 Open Microscopy Environment